﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace cssl040301
{
    public partial class MainPage : UserControl
    {
        bool isDrag;
        double diffX, diffY;

        public MainPage()
        {
            InitializeComponent();
            foreach (UIElement ui in faceCanvas.Children)
            {
                ui.MouseLeftButtonDown += new MouseButtonEventHandler(image_MouseLeftButtonDown);
                ui.MouseMove += new MouseEventHandler(image_MouseMove);
                ui.MouseLeftButtonUp += new MouseButtonEventHandler(image_MouseLeftButtonUp);
            }
        }

        private void image_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            UIElement s = sender as UIElement;
            s.CaptureMouse();
            SetTop(s, faceCanvas);
            isDrag = true;
            diffX = e.GetPosition(s).X;
            diffY = e.GetPosition(s).Y;
        }

        private void image_MouseMove(object sender, MouseEventArgs e)
        {
            if (isDrag)
            {
                UIElement s = sender as UIElement;
                double newX = e.GetPosition(faceCanvas).X - diffX;
                double newY = e.GetPosition(faceCanvas).Y - diffY;
                Canvas.SetLeft(s, newX);
                Canvas.SetTop(s, newY);
            }
        }

        private void image_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            if (isDrag)
            {
                UIElement s = sender as UIElement;
                s.ReleaseMouseCapture();
                isDrag = false;
            }
        }

        private void SetTop(UIElement s, Canvas c)
        {
            int maxZ = Canvas.GetZIndex(c.Children[0]);

            foreach (UIElement e in c.Children)
                maxZ = Math.Max(maxZ, Canvas.GetZIndex(e));

            Canvas.SetZIndex(s, maxZ + 1);
        }
    }
}
