﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace cssl050101
{
    public partial class MainPage : UserControl
    {
        bool isRotate;
        double oldX, oldY;
        double oldRotationX, oldRotationY;

        public MainPage()
        {
            InitializeComponent();
        }

        private void imageStackPanel_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (!isRotate)
            {
                isRotate = true;
                UIElement s = sender as UIElement;
                oldX = e.GetPosition(s).X;
                oldY = e.GetPosition(s).Y;
                oldRotationX = imageProjection.RotationX;
                oldRotationY = imageProjection.RotationY;
                imageStackPanel.CaptureMouse();
            }
        }

        private void imageStackPanel_MouseMove(object sender, MouseEventArgs e)
        {
            if (isRotate)
            {
                UIElement s = sender as UIElement;
                double dx = -(e.GetPosition(s).X - oldX);
                double dy = e.GetPosition(s).Y - oldY;
                imageProjection.RotationY =
                    oldRotationY + dx * 180 / image1.ActualWidth;
                imageProjection.RotationX =
                    oldRotationX + dy * 180 / image1.ActualHeight;
            }
        }

        private void imageStackPanel_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            imageStackPanel.ReleaseMouseCapture();
            isRotate = false;
        }
    }
}
