﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

namespace cssl050202
{
    public partial class MainPage : UserControl
    {
        int start = 0;
        List<Image> slotImages = new List<Image>();
        bool isStop;
        string[] imageName = new string[] { "slot1.png", "slot2.png",
            "slot3.png", "slot4.png", "slot5.png", "slot6.png" };

        public MainPage()
        {
            InitializeComponent();
            foreach (Image i in slotStackPanel.Children)
                slotImages.Add(i);
            SetImages();
            isStop = true;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            if (isStop)
            {
                isStop = false;
                slotAnime.Begin();
                button1.Content = "停止";
            }
            else
            {
                isStop = true;
                button1.Content = "開始";
            }
        }

        private void Storyboard_Completed(object sender, EventArgs e)
        {
            Storyboard s = sender as Storyboard;
            s.Stop();
            if (--start < 0)
                start = imageName.GetUpperBound(0);
            SetImages();
            if (!isStop)
               s.Begin();
        }

        void SetImages()
        {
            int idx = start;
            foreach (Image myImage in slotImages)
            {
                myImage.Source = new BitmapImage(new Uri("Images/" + imageName[idx], UriKind.Relative));
                if (++idx > imageName.GetUpperBound(0))
                    idx = 0;
            }
        }
    }
}
