﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace cssl050203
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            StartAnimation(canvas1);
        }

        private void StartAnimation(Canvas myCanvas)
        {
            double cx = myCanvas.ActualWidth / 2,
                cy = myCanvas.ActualHeight / 2;
            int count = 12;
            double outerRadius = 32, innnerRadius = 20, barHeight = 8;

            myCanvas.Children.Clear();

            Storyboard spinStoryboard = new Storyboard();

            for (int i = 0; i < count; i++)
            {
                Rectangle myRect = new Rectangle()
                {
                    Width = outerRadius - innnerRadius,
                    Height = barHeight,
                    Fill = new SolidColorBrush(Colors.White),
                    RadiusX = 2, RadiusY = 2,
                    Opacity = 0
                };

                Canvas.SetLeft(myRect, cx + innnerRadius);
                Canvas.SetTop(myRect, cy - barHeight / 2);

                RotateTransform r = new RotateTransform()
                {
                    CenterX = -innnerRadius, CenterY = barHeight / 2,
                    Angle = i * (360.0 / count)
                };
                myRect.RenderTransform = r;

                DoubleAnimationUsingKeyFrames myAnimation =
                    new DoubleAnimationUsingKeyFrames() {
                        Duration = new Duration(TimeSpan.FromMilliseconds(1000)),
                        BeginTime = TimeSpan.FromMilliseconds(1000 / count * i),
                        RepeatBehavior = RepeatBehavior.Forever };

                myAnimation.KeyFrames.Add(getKeyFrame(1,0));
                myAnimation.KeyFrames.Add(getKeyFrame(0.9, 250));
                myAnimation.KeyFrames.Add(getKeyFrame(0.3, 500));
                myAnimation.KeyFrames.Add(getKeyFrame(0.1, 1000)); 

                Storyboard.SetTarget(myAnimation, myRect);
                Storyboard.SetTargetProperty(myAnimation,
                    new PropertyPath("Opacity"));
                spinStoryboard.Children.Add(myAnimation);
                myCanvas.Children.Add(myRect);
            }
            spinStoryboard.Begin();
        }

        LinearDoubleKeyFrame getKeyFrame(double value, double milliSeconds)
        {
            return new LinearDoubleKeyFrame() {Value = value,
                KeyTime = KeyTime.FromTimeSpan(TimeSpan.FromMilliseconds(milliSeconds))};
        }
    }
}
