﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Linq;

namespace cssl060302
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }
        
        private void button1_Click(object sender, RoutedEventArgs e)
        {
            XElement xmlroot = XElement.Load("Cdlist.xml");
            string result = "";

            switch (comboBox1.SelectedIndex)
            {
                case 0: // from句
                    var cds = from c in xmlroot.Elements("CD") select c;
                    foreach (XElement cd in cds)
                        result += cd.Element("Title").Value + "\n";
                    break;
                case 1: // where句
                    var tracksLess3 = from c in xmlroot.Elements("CD").Elements("Track")
                                 where int.Parse(c.Attribute("No").Value) < 3
                                 select c;
                    foreach (XElement track in tracksLess3)
                        result += track.Element("{http://www.kkasahara.com/cd}Title").Value + "\n";
                    break;
                case 2: // select句
                    var trackNames = from c in xmlroot.Elements("CD").Elements("Track")
                                     where int.Parse(c.Attribute("No").Value) < 3
                                     select c.Element("{http://www.kkasahara.com/cd}Title").Value;
                    foreach (string title in trackNames)
                        result += title + "\n";
                    break;
                case 3: // group by句
                    var trackGroups = from c in xmlroot.Elements("CD").Elements("Track")
                                      group c.Element("{http://www.kkasahara.com/cd}Title").Value
                                      by c.Element("{http://www.kkasahara.com/cd}Title").Value.Length;
                    foreach (var trackGroup in trackGroups)
                    {
                        result += "文字数" + trackGroup.Key.ToString() + "\n";
                        foreach (string track in trackGroup)
                            result += "  " + track + "\n";
                    }
                    break;
                case 4: // order by句
                    var tracksByTime = from c in xmlroot.Elements("CD").Elements("Track")
                                       orderby TimeSpan.Parse(c.Element("Playtime").Value)
                                       select c;
                        foreach (var track in tracksByTime)
                            result += track.Element("Playtime").Value + " " + track.Element("{http://www.kkasahara.com/cd}Title").Value + "\n";
                        break;
                case 5: // into句
                        var trackGroupsByLength = from c in xmlroot.Elements("CD").Elements("Track")
                                                  group c.Element("{http://www.kkasahara.com/cd}Title").Value
                                                  by c.Element("{http://www.kkasahara.com/cd}Title").Value.Length
                                                  into groupData orderby groupData.Key
                                                  select groupData;
                        foreach (var trackGroup in trackGroupsByLength)
                        {
                            result += "文字数" + trackGroup.Key.ToString() + "\n";
                            foreach (string track in trackGroup)
                                result += "  " + track + "\n";
                        }
                        break;
                case 6: // let句
                        var trackGroups2 = from c in xmlroot.Elements("CD").Elements("Track")
                                          let title = c.Element("{http://www.kkasahara.com/cd}Title").Value
                                          group title by title.Length;
                        foreach (var trackGroup in trackGroups2)
                        {
                            result += "文字数" + trackGroup.Key.ToString() + "\n";
                            foreach (string track in trackGroup)
                                result += "  " + track + "\n";
                        }
                        break;
                case 7: // 複数のfrom句
                        var tracksWithCd = from cd in xmlroot.Elements("CD")
                                           from track in cd.Elements("Track")
                                           from trackTitle in track.Elements("{http://www.kkasahara.com/cd}Title")
                                           select new { CDTitle = cd.Element("Title").Value, TrackTitle = trackTitle.Value };
                        foreach (var track in tracksWithCd)
                            result += track.CDTitle + " : " + track.TrackTitle + "\n";
                        break;
            }
            textBox1.Text = result;
        }
    }
}