﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Linq;

namespace cssl060303
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            loadXml();
        }

        private void loadXml()
        {
            XElement xmlroot = XElement.Load("Cdlist.xml");
            var cds = from c in xmlroot.Elements("CD")
                      select new CD(c.Element("Title").Value,
                          (from d in c.Elements("Track")
                           select new Track(d.Element("{http://www.kkasahara.com/cd}Title").Value)));

            treeView1.ItemsSource = cds;
        }
    }

    public class CD
    {
        public List<Track> Tracks { get; set; }
        public string CDName { get; set; }

        public CD(string title, IEnumerable<Track> d)
        {
            CDName = title;
            Tracks = d.ToList<Track>();
        }
    }

    public class Track
    {
        public string TrackName { get; set; }
        public Track(string trackName)
        {
            TrackName = trackName;
        }
    }
}
