﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;

namespace cssl060402
{
    [ScriptableType()]
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            HtmlPage.RegisterScriptableObject("Page", this);
        }

        [ScriptableMember()]
        public void ChangePlayPosition(double current, double duration)
        {
            timeTextBlock.Text = string.Format("{0:0000}秒 / {1:0000}秒", current, duration);
        }

        [ScriptableMember()]
        public void ChangePlayState(int state)
        {
            string message = "";
            switch (state)
            {
                case -1:
                    message = "未開始";
                    break;
                case 0:
                    message = "終了";
                    break;
                case 1:
                    message = "再生中";
                    break;
                case 2:
                    message = "一時停止";
                    break;
                case 3:
                    message = "バッファリング";
                    break;
                case 5:
                    message = "頭出し済み";
                    break;
                default:
                    message = state.ToString();
                    break;
            }
            statusTextBlock.Text = message;
        }

        private void startButton_Click(object sender, RoutedEventArgs e)
        {
            HtmlPage.Window.Invoke("loadVideo", videoIdTextBox.Text);
        }

        private void pauseButton_Click(object sender, RoutedEventArgs e)
        {
            HtmlPage.Window.Invoke("pausePlay", null);
        }

        private void resumeButton_Click(object sender, RoutedEventArgs e)
        {
            HtmlPage.Window.Invoke("startPlay", null);
        }
    }
}
