﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.IO;
using System.Windows.Resources;

namespace cssl070203
{
    public partial class MainPage : UserControl
    {
        WebClient wc;
        List<string> yubinList;

        public MainPage()
        {
            InitializeComponent();
            wc = new WebClient();
            wc.OpenReadCompleted += new OpenReadCompletedEventHandler(wc_OpenReadCompleted);
        }

        void wc_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            if (!e.Cancelled && e.Error == null)
            {
                Stream zipPackageStream = e.Result;
                StreamResourceInfo zipSri =
                    new StreamResourceInfo(zipPackageStream, null);
                StreamResourceInfo textSri =
                    Application.GetResourceStream(zipSri, new Uri("Yubin.txt", UriKind.Relative));
                StreamReader sr = new StreamReader(textSri.Stream);

                string buffer = sr.ReadLine();

                yubinList = new List<string>();
                while (buffer != null)
                {
                    yubinList.Add(buffer);
                    buffer = sr.ReadLine();
                }
                processSerach();
            }
            button1.IsEnabled = true;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            if (yubinList == null)
            {
                wc.OpenReadAsync(new Uri("Yubin.zip", UriKind.Relative));
                button1.IsEnabled = false;
            }
            else
                processSerach();
        }

        private void processSerach()
        {
            if (textBox1.Text == "")
                return;

            string searchNum = textBox1.Text.Replace("-", "");
            listBox1.Items.Clear();
            for (int i = 0; i < yubinList.Count; i++)
                if (yubinList[i].IndexOf(searchNum) == 0)
                    listBox1.Items.Add(yubinList[i]);
        }
    }
}
