﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.IO;
using System.Web.Hosting;

namespace cssl070302.Web
{
    // メモ: [リファクター] メニューの [名前の変更] コマンドを使用すると、コード、svc、および config ファイルで同時にクラス名 "ZipService" を変更できます。
    public class ZipService : IZipService
    {
        public ZipData[] ZipSearch(string zip)
        {
            string filePath = Path.Combine(
                HostingEnvironment.ApplicationPhysicalPath,
                "Yubin.txt");
            StreamReader sr = new StreamReader(filePath);
            List<ZipData> zipList = new List<ZipData>();
            string searchZip = zip.Replace("-", "");
            string buff = sr.ReadLine();
            while (buff != null)
            {
                if (buff.IndexOf(searchZip) == 0)
                {
                    int n = Math.Max(0, buff.IndexOf(","));
                    zipList.Add(new ZipData() { Zip = buff.Substring(0, n),
                        Address = buff.Substring(n + 1)});
                }
                buff = sr.ReadLine();
            }
            sr.Close();
            return zipList.ToArray();
        }
    }

    [DataContract]
    public class ZipData
    {
        [DataMember]
        public string Zip { get; set; }

        [DataMember]
        public string Address { get; set; }
    }

}
